(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('ng-social-links', ['exports', '@angular/core', '@angular/common'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global['ng-social-links'] = {}, global.ng.core, global.ng.common));
}(this, (function (exports, i0, i1) { 'use strict';

    var DEFAULT_SHARE_URL_CONFIG_TOKEN = new i0.InjectionToken('ng-default-social-share-config');

    var NgSocialLinksService = /** @class */ (function () {
        function NgSocialLinksService(document, defaultConfig) {
            this.document = document;
            this.defaultConfig = defaultConfig;
        }
        NgSocialLinksService.prototype.getSocialLink = function (provider, config) {
            var url = (config === null || config === void 0 ? void 0 : config.url) || this.defaultConfig.url || this.document.location.href;
            var text = (config === null || config === void 0 ? void 0 : config.text) || this.defaultConfig.text;
            var body = (config === null || config === void 0 ? void 0 : config.body) || this.defaultConfig.body;
            if (!url) {
                throw new Error('Mandatory parameter is missing: url.');
            }
            switch (provider) {
                case 'fb':
                    return 'https://www.facebook.com/sharer/sharer.php?u=' + url;
                case 'tw':
                    return 'https://twitter.com/intent/tweet?url=' + url + (text ? '&text=' + text : '');
                case 'li':
                    return 'https://www.linkedin.com/sharing/share-offsite/?url=' + url + (text ? '/&summary=' + text : '');
                case 'mt':
                    return ('mailto:' +
                        (text ? '?subject=' + text : '') +
                        (text ? '&body=' : '?body=') +
                        (body ? body : '') +
                        ' ' +
                        url);
                default:
                    throw new Error("Unknown social share provider: " + provider);
            }
        };
        return NgSocialLinksService;
    }());
    NgSocialLinksService.ɵprov = i0.ɵɵdefineInjectable({ factory: function NgSocialLinksService_Factory() { return new NgSocialLinksService(i0.ɵɵinject(i1.DOCUMENT), i0.ɵɵinject(DEFAULT_SHARE_URL_CONFIG_TOKEN)); }, token: NgSocialLinksService, providedIn: "root" });
    NgSocialLinksService.decorators = [
        { type: i0.Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    NgSocialLinksService.ctorParameters = function () { return [
        { type: Document, decorators: [{ type: i0.Inject, args: [i1.DOCUMENT,] }] },
        { type: undefined, decorators: [{ type: i0.Inject, args: [DEFAULT_SHARE_URL_CONFIG_TOKEN,] }] }
    ]; };

    var NgSocialLinksModule = /** @class */ (function () {
        function NgSocialLinksModule() {
        }
        NgSocialLinksModule.forRoot = function (config) {
            return {
                ngModule: NgSocialLinksModule,
                providers: [
                    NgSocialLinksService,
                    { provide: DEFAULT_SHARE_URL_CONFIG_TOKEN, useValue: config || {} }
                ]
            };
        };
        return NgSocialLinksModule;
    }());
    NgSocialLinksModule.decorators = [
        { type: i0.NgModule }
    ];

    /*
     * Public API Surface of ng-social-links
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.NgSocialLinksModule = NgSocialLinksModule;
    exports.NgSocialLinksService = NgSocialLinksService;
    exports.ɵa = DEFAULT_SHARE_URL_CONFIG_TOKEN;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ng-social-links.umd.js.map
