import { InjectionToken, ɵɵdefineInjectable, ɵɵinject, Injectable, Inject, NgModule } from '@angular/core';
import { DOCUMENT } from '@angular/common';

const DEFAULT_SHARE_URL_CONFIG_TOKEN = new InjectionToken('ng-default-social-share-config');

class NgSocialLinksService {
    constructor(document, defaultConfig) {
        this.document = document;
        this.defaultConfig = defaultConfig;
    }
    getSocialLink(provider, config) {
        const url = (config === null || config === void 0 ? void 0 : config.url) || this.defaultConfig.url || this.document.location.href;
        const text = (config === null || config === void 0 ? void 0 : config.text) || this.defaultConfig.text;
        const body = (config === null || config === void 0 ? void 0 : config.body) || this.defaultConfig.body;
        if (!url) {
            throw new Error('Mandatory parameter is missing: url.');
        }
        switch (provider) {
            case 'fb':
                return 'https://www.facebook.com/sharer/sharer.php?u=' + url;
            case 'tw':
                return 'https://twitter.com/intent/tweet?url=' + url + (text ? '&text=' + text : '');
            case 'li':
                return 'https://www.linkedin.com/sharing/share-offsite/?url=' + url + (text ? '/&summary=' + text : '');
            case 'mt':
                return ('mailto:' +
                    (text ? '?subject=' + text : '') +
                    (text ? '&body=' : '?body=') +
                    (body ? body : '') +
                    ' ' +
                    url);
            default:
                throw new Error(`Unknown social share provider: ${provider}`);
        }
    }
}
NgSocialLinksService.ɵprov = ɵɵdefineInjectable({ factory: function NgSocialLinksService_Factory() { return new NgSocialLinksService(ɵɵinject(DOCUMENT), ɵɵinject(DEFAULT_SHARE_URL_CONFIG_TOKEN)); }, token: NgSocialLinksService, providedIn: "root" });
NgSocialLinksService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
NgSocialLinksService.ctorParameters = () => [
    { type: Document, decorators: [{ type: Inject, args: [DOCUMENT,] }] },
    { type: undefined, decorators: [{ type: Inject, args: [DEFAULT_SHARE_URL_CONFIG_TOKEN,] }] }
];

class NgSocialLinksModule {
    static forRoot(config) {
        return {
            ngModule: NgSocialLinksModule,
            providers: [
                NgSocialLinksService,
                { provide: DEFAULT_SHARE_URL_CONFIG_TOKEN, useValue: config || {} }
            ]
        };
    }
}
NgSocialLinksModule.decorators = [
    { type: NgModule }
];

/*
 * Public API Surface of ng-social-links
 */

/**
 * Generated bundle index. Do not edit.
 */

export { NgSocialLinksModule, NgSocialLinksService, DEFAULT_SHARE_URL_CONFIG_TOKEN as ɵa };
//# sourceMappingURL=ng-social-links.js.map
